import { ElementRef, ComponentFactoryResolver, ViewContainerRef, QueryList } from '@angular/core';
import { ExtBase } from './ext.base';
export interface ExtGridColumn {
    text?: string;
    width?: number;
    flex?: number;
    dataIndex?: string;
}
export interface ExtStore {
    xtype?: string;
    fields?: Array<Object>;
    data?: Array<Object>;
}
export declare class ExtGridMetaData {
    static XTYPE: string;
    static INPUTNAMES: string[];
    static OUTPUTS: any[];
    static OUTPUTNAMES: string[];
}
export declare class ExtGrid extends ExtBase {
    constructor(myElement: ElementRef, componentFactoryResolver: ComponentFactoryResolver, viewContainerRef: ViewContainerRef);
    ExtBaseRef: QueryList<ViewContainerRef>;
    private dynamicTarget;
    ngAfterContentInit(): void;
    ngOnInit(): void;
}
