"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var ext_base_1 = require('./ext.base');
var ExtGridMetaData = (function () {
    function ExtGridMetaData() {
    }
    ExtGridMetaData.XTYPE = 'grid';
    ExtGridMetaData.INPUTNAMES = [
        'nofit',
        'title',
        'columns',
        'selModel',
        'plugins',
        'store'
    ];
    ExtGridMetaData.OUTPUTS = [
        { name: 'select', parameters: 'control,record,eOpts' },
        { name: 'columnsort', parameters: 'control,column,direction,eOpts' },
        { name: 'selectionchange', parameters: 'this,selected,eOpts' },
        { name: 'beforecellclick', parameters: 'this,td,cellIndex,record,tr,rowIndex,e,eOpts' },
        { name: 'enable', parameters: 'this,eOpts' },
        { name: 'headerclick', parameters: 'ct,column,e,t,eOpts' }
    ];
    ExtGridMetaData.OUTPUTNAMES = [];
    return ExtGridMetaData;
}());
exports.ExtGridMetaData = ExtGridMetaData;
ext_base_1.ExtBase.iterateIt(ExtGridMetaData);
var ExtGrid = (function (_super) {
    __extends(ExtGrid, _super);
    function ExtGrid(myElement, componentFactoryResolver, viewContainerRef) {
        _super.call(this, myElement, componentFactoryResolver, viewContainerRef, ExtGridMetaData);
    }
    ExtGrid.prototype.ngAfterContentInit = function () { this.AfterContentInit(this.ExtBaseRef); };
    ExtGrid.prototype.ngOnInit = function () { this.OnInit(this.dynamicTarget); };
    __decorate([
        core_1.ContentChildren(ext_base_1.ExtBase, { read: core_1.ViewContainerRef }), 
        __metadata('design:type', core_1.QueryList)
    ], ExtGrid.prototype, "ExtBaseRef", void 0);
    __decorate([
        core_1.ViewChild('dynamicTarget', { read: core_1.ViewContainerRef }), 
        __metadata('design:type', core_1.ViewContainerRef)
    ], ExtGrid.prototype, "dynamicTarget", void 0);
    ExtGrid = __decorate([
        core_1.Component({
            selector: 'ext-' + ExtGridMetaData.XTYPE,
            inputs: ExtGridMetaData.INPUTNAMES.concat('config'),
            outputs: ExtGridMetaData.OUTPUTNAMES.concat('ready'),
            providers: [{ provide: ext_base_1.ExtBase, useExisting: core_1.forwardRef(function () { return ExtGrid; }) }],
            template: "<template #dynamicTarget></template>"
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.ComponentFactoryResolver, core_1.ViewContainerRef])
    ], ExtGrid);
    return ExtGrid;
}(ext_base_1.ExtBase));
exports.ExtGrid = ExtGrid;
//# sourceMappingURL=ext.grid.js.map