"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var ext_base_1 = require('./ext.base');
var ExtButtonMetaData = (function () {
    function ExtButtonMetaData() {
    }
    ExtButtonMetaData.XTYPE = 'button';
    ExtButtonMetaData.INPUTNAMES = [
        'nofit',
        'text',
        'ui',
        'width',
        'height'
    ];
    ExtButtonMetaData.OUTPUTS = [
        { name: 'click', parameters: 'control,record,eOpts' }
    ];
    ExtButtonMetaData.OUTPUTNAMES = [];
    return ExtButtonMetaData;
}());
exports.ExtButtonMetaData = ExtButtonMetaData;
ext_base_1.ExtBase.iterateIt(ExtButtonMetaData);
var ExtButton = (function (_super) {
    __extends(ExtButton, _super);
    function ExtButton(myElement, componentFactoryResolver, viewContainerRef) {
        _super.call(this, myElement, componentFactoryResolver, viewContainerRef, ExtButtonMetaData);
    }
    ExtButton.prototype.ngAfterContentInit = function () { this.AfterContentInit(this.ExtJSBaseRef); };
    ExtButton.prototype.ngOnInit = function () { this.OnInit(this.dynamicTarget); };
    __decorate([
        core_1.ContentChildren(ext_base_1.ExtBase, { read: core_1.ViewContainerRef }), 
        __metadata('design:type', core_1.QueryList)
    ], ExtButton.prototype, "ExtJSBaseRef", void 0);
    __decorate([
        core_1.ViewChild('dynamicTarget', { read: core_1.ViewContainerRef }), 
        __metadata('design:type', core_1.ViewContainerRef)
    ], ExtButton.prototype, "dynamicTarget", void 0);
    ExtButton = __decorate([
        core_1.Component({
            selector: 'ext-' + ExtButtonMetaData.XTYPE,
            inputs: ExtButtonMetaData.INPUTNAMES.concat('config'),
            outputs: ExtButtonMetaData.OUTPUTNAMES.concat('ready'),
            providers: [
                { provide: ext_base_1.ExtBase, useExisting: core_1.forwardRef(function () { return ExtButton; }) }
            ],
            template: "<template #dynamicTarget></template>"
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.ComponentFactoryResolver, core_1.ViewContainerRef])
    ], ExtButton);
    return ExtButton;
}(ext_base_1.ExtBase));
exports.ExtButton = ExtButton;
//# sourceMappingURL=ext.button.js.map