"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var ext_base_1 = require('./ext.base');
var ExtListMetaData = (function () {
    function ExtListMetaData() {
    }
    ExtListMetaData.XTYPE = 'list';
    ExtListMetaData.INPUTS = [];
    ExtListMetaData.OUTPUTS = [
        { name: 'select', parameters: 'control,record,eOpts' },
    ];
    ExtListMetaData.OUTPUTNAMES = [];
    return ExtListMetaData;
}());
exports.ExtListMetaData = ExtListMetaData;
ext_base_1.ExtBase.iterateIt(ExtListMetaData);
var ExtList = (function (_super) {
    __extends(ExtList, _super);
    function ExtList(myElement, componentFactoryResolver, viewContainerRef) {
        _super.call(this, myElement, componentFactoryResolver, viewContainerRef, ExtListMetaData);
    }
    ExtList.prototype.ngAfterContentInit = function () { this.AfterContentInit(this.ExtBaseRef); };
    ExtList.prototype.ngOnInit = function () { this.OnInit(this.dynamicTarget); };
    __decorate([
        core_1.ContentChildren(ext_base_1.ExtBase, { read: core_1.ViewContainerRef }), 
        __metadata('design:type', core_1.QueryList)
    ], ExtList.prototype, "ExtBaseRef", void 0);
    __decorate([
        core_1.ViewChild('dynamicTarget', { read: core_1.ViewContainerRef }), 
        __metadata('design:type', core_1.ViewContainerRef)
    ], ExtList.prototype, "dynamicTarget", void 0);
    ExtList = __decorate([
        core_1.Component({
            selector: 'ext-' + ExtListMetaData.XTYPE,
            inputs: ['config'],
            outputs: ExtListMetaData.OUTPUTNAMES.concat('ready'),
            providers: [
                { provide: ext_base_1.ExtBase, useExisting: core_1.forwardRef(function () { return ExtList; }) }
            ],
            template: "<template #dynamicTarget></template>"
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.ComponentFactoryResolver, core_1.ViewContainerRef])
    ], ExtList);
    return ExtList;
}(ext_base_1.ExtBase));
exports.ExtList = ExtList;
//# sourceMappingURL=ext.list.js.map