"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var ext_base_1 = require('./ext.base');
var ExtToolbarMetaData = (function () {
    function ExtToolbarMetaData() {
    }
    ExtToolbarMetaData.XTYPE = 'toolbar';
    ExtToolbarMetaData.INPUTNAMES = [
        'layout',
        'docked'
    ];
    ExtToolbarMetaData.OUTPUTS = [];
    ExtToolbarMetaData.OUTPUTNAMES = [];
    return ExtToolbarMetaData;
}());
exports.ExtToolbarMetaData = ExtToolbarMetaData;
ext_base_1.ExtBase.iterateIt(ExtToolbarMetaData);
var ExtToolbar = (function (_super) {
    __extends(ExtToolbar, _super);
    function ExtToolbar(myElement, componentFactoryResolver, viewContainerRef) {
        _super.call(this, myElement, componentFactoryResolver, viewContainerRef, ExtToolbarMetaData);
    }
    ExtToolbar.prototype.ngAfterContentInit = function () { this.AfterContentInit(this.ExtBaseRef); };
    ExtToolbar.prototype.ngOnInit = function () { this.OnInit(this.dynamicTarget); };
    __decorate([
        core_1.ContentChildren(ext_base_1.ExtBase, { read: core_1.ViewContainerRef }), 
        __metadata('design:type', core_1.QueryList)
    ], ExtToolbar.prototype, "ExtBaseRef", void 0);
    __decorate([
        core_1.ViewChild('dynamicTarget', { read: core_1.ViewContainerRef }), 
        __metadata('design:type', core_1.ViewContainerRef)
    ], ExtToolbar.prototype, "dynamicTarget", void 0);
    ExtToolbar = __decorate([
        core_1.Component({
            selector: 'ext-' + ExtToolbarMetaData.XTYPE,
            inputs: ExtToolbarMetaData.INPUTNAMES.concat('config'),
            outputs: ExtToolbarMetaData.OUTPUTNAMES.concat('ready'),
            providers: [
                { provide: ext_base_1.ExtBase, useExisting: core_1.forwardRef(function () { return ExtToolbar; }) }
            ],
            template: "<template #dynamicTarget></template>"
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, core_1.ComponentFactoryResolver, core_1.ViewContainerRef])
    ], ExtToolbar);
    return ExtToolbar;
}(ext_base_1.ExtBase));
exports.ExtToolbar = ExtToolbar;
//# sourceMappingURL=ext.toolbar.js.map